﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Public Class frmMain
   Private moDataTable As DataTable
   Private moShapefile As DynamicSegmentationShapeFile
   Private msShapefilePath As String = "..\..\Data\DynSeg.shp"
   Private moAsphaltSym As LineStyle
   Private moGravelSym As LineStyle
   Private moConcreteSym As LineStyle
   Private moMap As WinformsMap
   Private Sub frmMain_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      mCreateSymbology()

      mCreateDataTable()
      mLoadShapefile()
   End Sub
   Private Sub mLoadShapefile()
      moMap = WinformsMap1

      moShapefile = New DynamicSegmentationShapeFile(msShapefilePath)
      With moShapefile
         .DynSegTable = moDataTable
         .AsphaltSym = moAsphaltSym
         .GravelSym = moGravelSym
         .ConcreteSym = moConcreteSym
      End With

      moMap.MapUnit = GeographyUnit.Meter

      moMap.Overlays.Add("LayerOverlay", New LayerOverlay())
      CType(moMap.Overlays("LayerOverlay"), LayerOverlay).Layers.Add(moShapefile)

      moShapefile.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Blue, 2, False)
      moShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      moShapefile.Open()
      Dim oFeature = moShapefile.QueryTools.GetFeatureById("1", ReturningColumnsType.NoColumns)

      moMap.CurrentExtent = oFeature.GetBoundingBox

      moMap.Refresh()


   End Sub
   Private Sub mCreateSymbology()
      moGravelSym = LineStyles.LocalRoad3
      moGravelSym.CenterPen.Color = GeoColor.SimpleColors.White
      moGravelSym.CenterPen.Width = 3

      moAsphaltSym = LineStyles.LocalRoad3
      moAsphaltSym.CenterPen.Color = GeoColor.SimpleColors.Black
      moAsphaltSym.CenterPen.Width = 3

      moConcreteSym = LineStyles.LocalRoad3
      moConcreteSym.CenterPen.Color = GeoColor.SimpleColors.Red
      moConcreteSym.CenterPen.Width = 3

   End Sub

   Private Sub mCreateDataTable()
      moDataTable = New DataTable
      Dim oColumn As DataColumn
      Dim oRow As DataRow

      dgvSegmentation.Columns.Clear()


      oColumn = New DataColumn("FeatureID", GetType(String))
      oColumn.Caption = "Feature ID"
      moDataTable.Columns.Add(oColumn)

      oColumn = New DataColumn("Type", GetType(String))
      moDataTable.Columns.Add(oColumn)

      oColumn = New DataColumn("DistanceFrom", GetType(Double))
      oColumn.Caption = "Distance From"
      moDataTable.Columns.Add(oColumn)

      oColumn = New DataColumn("DistanceTo", GetType(Double))
      oColumn.Caption = "Distance To"
      moDataTable.Columns.Add(oColumn)

      oColumn = New DataColumn("Description", GetType(String))
      moDataTable.Columns.Add(oColumn)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Line"
      oRow("DistanceFrom") = 0
      oRow("DistanceTo") = 10000
      oRow("Description") = "Asphalt"
      moDataTable.Rows.Add(oRow)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Line"
      oRow("DistanceFrom") = 10000
      oRow("DistanceTo") = 20000
      oRow("Description") = "Concrete"
      moDataTable.Rows.Add(oRow)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Line"
      oRow("DistanceFrom") = 20000
      oRow("DistanceTo") = 30000
      oRow("Description") = "Gravel"
      moDataTable.Rows.Add(oRow)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Line"
      oRow("DistanceFrom") = 30000
      oRow("DistanceTo") = 50000
      oRow("Description") = "Asphalt"
      moDataTable.Rows.Add(oRow)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Point"
      oRow("DistanceFrom") = 1000
      oRow("DistanceTo") = DBNull.Value
      oRow("Description") = "Wood Bridge"
      moDataTable.Rows.Add(oRow)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Point"
      oRow("DistanceFrom") = 5000
      oRow("DistanceTo") = DBNull.Value
      oRow("Description") = "Concrete Bridge"
      moDataTable.Rows.Add(oRow)

      oRow = moDataTable.NewRow
      oRow("FeatureID") = "1"
      oRow("Type") = "Point"
      oRow("DistanceFrom") = 14000
      oRow("DistanceTo") = DBNull.Value
      oRow("Description") = "14"" Culvert"
      moDataTable.Rows.Add(oRow)

      dgvSegmentation.DataSource = moDataTable

   End Sub
End Class
